public class UE9Aufgabe9 {

	public static void main(String[] args) {
		int[] haufen = initialisieren();
		spielen(haufen);
	}

	static int[] initialisieren() {
		int anzahlHaufen = IO.readInt("Anzahl an Haufen (>= 2):");
		while (anzahlHaufen < 2) {
			anzahlHaufen = IO.readInt("Fehler! Anzahl an Haufen (>= 2):");
		}
		int[] haufen = new int[anzahlHaufen];
		for (int h = 0; h < haufen.length; h++) {
			haufen[h] = anzahlHaufen;
		}
		return haufen;
	}

	static void spielen(int[] haufen) {
		int spieler = 1;
		while (true) {
			print(haufen);
			NimSpielzug zug = erfrageSpielzug(spieler);
			if (spielzugOk(haufen, zug)) {
				haufen[zug.haufen] -= zug.anzahl;
				if (spielEnde(haufen)) {
					IO.println("Spielende! Spieler " + spieler
							+ " hat gewonnen");
					return; // Ende
				} else {
					spieler = (spieler == 1) ? 2 : 1; // Wechsel
				}
			} else {
				IO.println("Ungltiger Spielzug! Spieler " + spieler
						+ " hat verloren!");
				return; // Ende
			}
		}
	}

	static boolean spielEnde(int[] haufen) {
		for (int anzahl : haufen) {
			if (anzahl > 0) {
				return false; // noch ein Streichholz vorhanden
			}
		}
		return true; // alle Haufen leer
	}

	static void print(int[] haufen) {
		IO.println();
		for (int h = 0; h < haufen.length; h++) {
			IO.println("Haufen " + h + ": " + haufen[h]);
		}
		IO.println();
	}

	static NimSpielzug erfrageSpielzug(int spieler) {
		IO.println("Spieler " + spieler + " ist am Zug!");
		NimSpielzug zug = new NimSpielzug();
		zug.haufen = IO.readInt("Nummer des Haufens: ");
		zug.anzahl = IO.readInt("Anzahl an Streichhlzern: ");
		return zug;
	}

	static boolean spielzugOk(int[] haufen, NimSpielzug zug) {
		if (zug.haufen < 0 || zug.haufen >= haufen.length) {
			return false; // ungueltige Haufennummer
		}
		if (haufen[zug.haufen] < zug.anzahl) {
			return false; // so viele Streichhlzer sind nicht mehr da
		}
		return true; // ok
	}

}

class NimSpielzug {
	int haufen;
	int anzahl;
}
